package org.sump.analyzer;

import java.io.IOException;

public class PollinDevice extends Device{
    /*
     * int readWert()
     * 
     * immer einen Wert von der seriellen Schnittstelle lesen
     * 
     * return:
     * wert
     * oder -1 fr kein Zeichen vorhanden
     * 
     * 
     */
    private boolean debug=true;
    
	private int readWert() 
    {
    	int wert=-1; // no value available
    	if(debug) System.out.println("readbyte1");
    		        
        try {
            if (inputStream.available() > 0) {
                wert=inputStream.read();
                if(debug)System.out.println(wert);
            }
       
        } catch(IOException e) { System.out.println(e); }
        return wert;
    }
	private int readValue() // Wert lesen mit Wiederholung, falls kein Zeichen vorhanden
	{
		int versuche=10;
		boolean flag=true;
		int value=0;
		
		while(versuche>0 && flag==true)
		{
			value=readWert();
			if(value!=-1) flag=false;
			else 	
			{
				try{ Thread.sleep(10);}catch( InterruptedException e){};		}
			}
		return value;
		
	}
    
	@Override 
		public CapturedData run() throws IOException, InterruptedException {
			
		sendCommand('s');	// CPLD in Startzustand versezten
		try{ Thread.sleep(10);}catch( InterruptedException e){}; // kurz warten
		
		//sendCommand('u');	// slow sampling clk einstellen
		//try{ Thread.sleep(10);}catch( InterruptedException e){}; // kurz warten	

		sendCommand('s');	// CPLD in Startzustand versezten
		try{ Thread.sleep(10);}catch( InterruptedException e){}; // kurz warten
		
		sendCommand('d'); 	// Kommando fr Daten in Ram einlesen
		try{ Thread.sleep(200);}catch( InterruptedException e){}; // warten und CPLD Daten sammeln lassen

		sendCommand('s');	// CPLD in Startzustand versezten
		try{ Thread.sleep(10);}catch( InterruptedException e){}; // kurz warten
		

		int samples = 128;
		
		int[] buffer = new int[samples];
		
		int n;
		int wert;
		for(n=0;n<samples/2;n++) 
		{
			sendCommand('a'); 	// Kommando fr Daten in Ram einlesen
			//try{ Thread.sleep(1);}catch( InterruptedException e){}; // warten und CPLD Daten sammeln lassen
			wert=readValue();
			 //if(wert==-1)System.out.println("er---");
			if(wert==-1) wert=0xaa;// debug: error value
			buffer[n*2]=wert;
			sendCommand('s'); 	// Kommando fr Daten in Ram einlesen
			//try{ Thread.sleep(1);}catch( InterruptedException e){}; // warten und CPLD Daten sammeln lassen
			wert=readValue();
			 //if(wert==-1)System.out.println("er---");
			if(wert==-1) wert=0xaa; // debug: error value
			buffer[n*2+1]=wert;
		}
		
		int pos=0;
		int rate=2000000; // Hz
		int channels=8;
		return (new CapturedData(buffer, pos, rate, channels, channels));	
	}
}
